CMinimizer Class Referenceabstract
Basic data strctures and functions

A class for generalized minimization problems. More...

`#include <mia/core/minimizer.hh>`

Inheritance diagram for CMinimizer:
[legend]
Collaboration diagram for CMinimizer:
[legend]

## Data Structures

class | Problem
| Base class for all optimization problems that can be run by CMinimizer. More...

## Public Types

enum | EMinimizerResult { failure , success }
| enum to describe whether optimization succeeded More...
typedef CMinimizer | plugin_data
| plug-in searchpath typedef helper
typedef CMinimizer | plugin_type
| plug-in searchpath typedef helper
typedef std::shared_ptr< CMinimizer > | Pointer
| Pointer type of this minimizer.
typedef std::shared_ptr< Problem > | PProblem
| pointer type for the optimization problem
Public Types inherited from CPropertyFlagHolder
typedef std::set< const char * > | Set
| define the type of the set of flags

## Public Member Functions

| CMinimizer ()
int | run (CDoubleVector &x)
void | set_problem (PProblem x)
virtual | ~CMinimizer ()
Public Member Functions inherited from CProductBase
const char * | get_init_string () const
void | set_init_string (const char *init)
void | set_module (PPluginModule module)
Public Member Functions inherited from CPropertyFlagHolder
void | add (const char *property)
Set | get_missing_properties (const CPropertyFlagHolder &testset) const
bool | has (const char *property) const
bool | has_all_in (const CPropertyFlagHolder &testset) const
virtual | ~CPropertyFlagHolder ()

## Static Public Attributes

static const char *const | data_descr
| plug-in searchpath helper
static const char *const | type_descr
| plug-in searchpath helper

## Protected Member Functions

Problem & | get_problem ()
Problem * | get_problem_pointer ()
size_t | size () const

## Detailed Description

A class for generalized minimization problems.

This class defined the interface for a generalized minimizer that may use gradient information. Specific implementations are provided as plug-ins.

Definition at line 42 of file minimizer.hh.

## Member Typedef Documentation

## plugin_data

typedef CMinimizer CMinimizer::plugin_data

plug-in searchpath typedef helper

Definition at line 47 of file minimizer.hh.

## plugin_type

typedef CMinimizer CMinimizer::plugin_type

plug-in searchpath typedef helper

Definition at line 49 of file minimizer.hh.

## Pointer

typedef std::shared_ptr<CMinimizer> CMinimizer::Pointer

Pointer type of this minimizer.

Definition at line 52 of file minimizer.hh.

## PProblem

typedef std::shared_ptr<Problem> CMinimizer::PProblem

pointer type for the optimization problem

Definition at line 180 of file minimizer.hh.

## Member Enumeration Documentation

## EMinimizerResult

enum CMinimizer::EMinimizerResult

enum to describe whether optimization succeeded

Enumerator
failure | optimization failed
success | optimization succeeded

Definition at line 55 of file minimizer.hh.

## Constructor & Destructor Documentation

## CMinimizer()

CMinimizer::CMinimizer | ( |  | ) |

Construtor of the optimizer.

## ~CMinimizer()

virtual CMinimizer::~CMinimizer | ( |  | ) |

virtual

## Member Function Documentation

## get_problem()

CMinimizer::Problem & CMinimizer::get_problem | ( |  | ) |

inline protected

Returns
  a read/write reference to the current optimization problem

Definition at line 232 of file minimizer.hh.

Referenced by size().

## get_problem_pointer()

Problem * CMinimizer::get_problem_pointer | ( |  | ) |

protected

Returns
  a raw pointer to the optimization problem

## run()

int CMinimizer::run | ( | CDoubleVector & | x | ) |

Run the optimization

Parameters

  [in,out] | x | at entry contains the start point of the optimization at exit the optimized value

Returns
  returns a status whether the optimization succeeded or why it stopped

## set_problem()

void CMinimizer::set_problem | ( | PProblem | x | ) |

Set the optimization problem

Parameters

  x | problem to be optimized

## size()

size_t CMinimizer::size | ( |  | ) | const

protected

Returns
  the size (degrees of freedom) of the optimization problem

References get_problem().

## Field Documentation

## data_descr

const char* const CMinimizer::data_descr

static

plug-in searchpath helper

Definition at line 63 of file minimizer.hh.

## type_descr

const char* const CMinimizer::type_descr

static

plug-in searchpath helper

Definition at line 60 of file minimizer.hh.

The documentation for this class was generated from the following file:

- minimizer.hh